/* TECNISA - TECNOLOGIA EM INFORMTICA

NOME: 4045_DFSSTPS_CONFERE_ERROS_NF.SQL
DESCRIO:
   PROCEDIMENTO PARA VERIFICAR ERROS NOS LANAMENTOS DE NF

CRIAO:
21/10/99 - ROBERTO A. LOPES MARTINS

MANUTENES:
26/11/99 - PAULO GIOVANNI - CONVERSO P/ SQL-SERVER

@C:\Web_619\Sql\End_Conv\SqlServer\4045_DFSSTPS_CONFERE_ERROS.SQL
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'CONFERE_ERROS_NF'   AND
	        TYPE = 'P' 			           AND
	        U.UID = O.UID             	  AND
	        U.NAME = USER)

  DROP PROCEDURE CONFERE_ERROS_NF
  GO

CREATE PROCEDURE CONFERE_ERROS_NF
                 @P_CDFILIAL     VARCHAR(4),
                 @P_NRLANCTONF   VARCHAR(10),
                 @P_VRLANCAMENTO NUMERIC(16,2)

AS

/*VARIVEIS NORMAIS - INCIO*/
DECLARE @V_CDEMPRESA    VARCHAR(02);
DECLARE @V_CDTIPOOPER   VARCHAR(04);
DECLARE @V_IDENTRSAID   VARCHAR(01);
DECLARE @V_IDORIGDEST   VARCHAR(01);
DECLARE @V_CDFORNECED   VARCHAR(21);
DECLARE @V_IDCONSPARFIS VARCHAR(01);
DECLARE @V_CDFILDEST    VARCHAR(04);
DECLARE @V_CDFILLANC    VARCHAR(04);
DECLARE @V_NRAUTOFORN   VARCHAR(10);
DECLARE @V_VRIMPOSTOT   NUMERIC(15,6);
DECLARE @V_FAIXATOLER   NUMERIC(15,6);
DECLARE @V_IDCONVRUNIAF VARCHAR(01);
DECLARE @V_IDCONQTDEAF  VARCHAR(01);
DECLARE @V_IDCONQTDEREC VARCHAR(01);
DECLARE @V_IDERROAVISO  VARCHAR(01);
DECLARE @V_DEVOLORIG    VARCHAR(10);
DECLARE @V_IDOPERDEVONF VARCHAR(01);
DECLARE @V_TESTE        VARCHAR(100);

DECLARE @V_NRDECTOTANF  NUMERIC;
DECLARE @V_VRPETOLEVRAF NUMERIC;
DECLARE @V_VRPETOLEQTAF NUMERIC;
DECLARE @V_VRNFRELACAF  NUMERIC(15,5);
DECLARE @V_QTNFRELACAF  NUMERIC(15,3);
DECLARE @V_QTITEMPROD   NUMERIC(15,3);
DECLARE @V_QTENTRMERC   NUMERIC;
DECLARE @V_VRPTOLQTITAF NUMERIC;
DECLARE @V_VRPTOLVRITAF NUMERIC;
DECLARE @V_PERCDIF      NUMERIC;
DECLARE @V_VALRMIN      NUMERIC;
DECLARE @V_VALRMAX      NUMERIC;
DECLARE @V_VRNOTAFISC   NUMERIC;

DECLARE @V_NRSEQITPROD  VARCHAR(04);
DECLARE @V_CDPRODUTO    VARCHAR(10);
DECLARE @V_CDMARCA      VARCHAR(05);
DECLARE @V_CDFILIORIG   VARCHAR(04);

DECLARE @V_NRLANCTONF   VARCHAR(10);
DECLARE @V_DIFPROD      VARCHAR(1);
DECLARE @V_NRORIGVENPAG NUMERIC;
DECLARE @V_IDPRODNFAF   VARCHAR(01);
DECLARE @V_CPRODAF      VARCHAR(10);

DECLARE @V_DTPROGENTAF     DATETIME;
DECLARE @V_IDCONSVLRMAF    VARCHAR(01);
DECLARE @V_IDCONSVLRMENAF  VARCHAR(01);
DECLARE @V_IDUTRELACFORNAF VARCHAR(01);

DECLARE @V_IDTIPODTPGTO VARCHAR(4);
DECLARE @V_IDUTILDTPROC VARCHAR(01);

DECLARE @V_IDNFGERADAVIAXML VARCHAR(1);
DECLARE @V_IDGERNFIGUALXML VARCHAR(1);

DECLARE @V_VRSOMAENCA     NUMERIC(15,5);
DECLARE @V_VRMENOENCA     NUMERIC(15,5);       
DECLARE @V_VRSOMAIMPO     NUMERIC(15,5);
DECLARE @V_VRMENOIMPO     NUMERIC(15,5);
DECLARE @V_VRSUBTRAIVENC  NUMERIC(15,5);

/*VARIVEIS NORMAIS - FIM*/

BEGIN
   /* CONFERNCIA DE ERROS E AVISOS DA NOTA FISCAL */
   SET @V_VRNFRELACAF = 0.00;
   SET @V_QTNFRELACAF = 0.000;
   SET @V_QTITEMPROD  = 0.000;

   SET @V_IDUTILDTPROC = 'N';

   /* PREENCHE AS VARIVEIS P/ CONTROLE DE CONSISTNCIA DE AF X NF */
   SELECT @V_VRPETOLEVRAF = ISNULL(VRPETOLEVRAF, 0.00),
          @V_VRPETOLEQTAF = ISNULL(VRPETOLEQTAF, 0.00),
          @V_NRDECTOTANF  = ISNULL(NRDECITOTANF, 2),
          @V_FAIXATOLER   = CASE ISNULL(VRFAIXTOLENF, 0.02)
                                  WHEN 0
                                  THEN 0.009
                                  ELSE ISNULL(VRFAIXTOLENF, 0.02)
                                  END,
          @V_IDCONSVLRMAF    = IDCONSVLRMAF,
          @V_IDCONSVLRMENAF  = IDCONSVLRMENAF,
          @V_IDUTRELACFORNAF = IDUTRELACFORNAF,
          @V_IDUTILDTPROC = ISNULL(IDUTILDTPROC,'N'),
          @V_IDGERNFIGUALXML = ISNULL(IDGERNFIGUALXML, 'N')
   FROM PARAMGERAL;


   DECLARE C_NOTAFISCAL CURSOR FOR
   SELECT CASE IDENTRSAIDOP WHEN 'E' THEN CDFILIRECE ELSE CDFILIEMIT END, CDTIPOOPER, IDENTRSAIDOP, CDFORNECED, ISNULL(IDORIGDESTNF,'F'), ISNULL(IDNFGERADAVIAXML, 'S')
   FROM NOTAFISCAL
   WHERE CDFILIAL   = @P_CDFILIAL AND
         NRLANCTONF = @P_NRLANCTONF;

   OPEN C_NOTAFISCAL;
   FETCH NEXT FROM C_NOTAFISCAL INTO @V_CDFILIORIG, @V_CDTIPOOPER, @V_IDENTRSAID, @V_CDFORNECED, @V_IDORIGDEST, @V_IDNFGERADAVIAXML;
   WHILE (@@FETCH_STATUS = 0)
   BEGIN
      FETCH NEXT FROM C_NOTAFISCAL INTO @V_CDFILIORIG, @V_CDTIPOOPER, @V_IDENTRSAID, @V_CDFORNECED, @V_IDORIGDEST,  @V_IDNFGERADAVIAXML;
   END;
   CLOSE C_NOTAFISCAL;
   DEALLOCATE C_NOTAFISCAL;

   DECLARE C_ITEMAUTF CURSOR FOR
   SELECT DISTINCT CDFILDEST, CDFILLANC, NRAUTOFORN,
                   DTPROGENTAF, NRLANCTONF
   FROM NFRELACAF
   WHERE CDFILIAL   = @P_CDFILIAL AND
         NRLANCTONF = @P_NRLANCTONF;

   OPEN C_ITEMAUTF;
   FETCH NEXT FROM C_ITEMAUTF INTO @V_CDFILDEST, @V_CDFILLANC, @V_NRAUTOFORN, @V_DTPROGENTAF, @V_NRLANCTONF;
   WHILE (@@FETCH_STATUS = 0)
   BEGIN
      FETCH NEXT FROM C_ITEMAUTF INTO @V_CDFILDEST, @V_CDFILLANC, @V_NRAUTOFORN, @V_DTPROGENTAF, @V_NRLANCTONF;
   END;
   CLOSE C_ITEMAUTF;
   DEALLOCATE C_ITEMAUTF;

   SELECT @V_IDOPERDEVONF = MAX(ISNULL(IDOPERDEVONF, 'N')),
          @V_IDCONSPARFIS = MAX(ISNULL(IDCONSPARFIS, 'S'))
   FROM TIPOOPERAC
   WHERE IDENTRSAIDOP = @V_IDENTRSAID AND
         CDTIPOOPER   = @V_CDTIPOOPER;

   UPDATE ITEMPRODUTO
   SET IDAVISOSITEM = '000000'
   WHERE (CDFILIAL   = @P_CDFILIAL)   AND
         (NRLANCTONF = @P_NRLANCTONF);


   UPDATE TRABITPROIMPOS
   SET IDAVISIMPOIT = '00000'
   WHERE (CDFILIMPOIT  = @P_CDFILIAL)   AND
         (NRLANCIMPOIT = @P_NRLANCTONF);

   IF (NOT(@V_CDTIPOOPER  IN ('09','10'))) AND (NOT ((@V_IDNFGERADAVIAXML = 'S') AND (@V_IDGERNFIGUALXML = 'S'))) BEGIN
      SELECT @V_IDERROAVISO = MAX(IDERROAVISOFIL)
      FROM ERROAVISONFFIL
      WHERE CDERROAVISOFIL = 'AV09'
        AND CDFILIAL = @V_CDFILIORIG;

      IF @V_IDERROAVISO IS NULL BEGIN
         SELECT @V_IDERROAVISO = MAX(IDERROAVISO)
         FROM ERROAVISONF
         WHERE CDERROAVISO = 'AV09';
      END;

      /* (AVISO) ITEM COM CDIGO DA SITUAO TRIBUTRIA INVLIDO */
      UPDATE ITEMPRODUTO
      SET IDAVISOSITEM = '1' + SUBSTRING(IDAVISOSITEM,2,5)
      WHERE (CDFILIAL   = @P_CDFILIAL)   AND
            (NRLANCTONF = @P_NRLANCTONF) AND
            ((CDSITUTRIBPR IS NULL) OR (DATALENGTH(LTRIM(RTRIM(CDSITUTRIBPR))) < 3)) AND
            (@V_IDERROAVISO <> 'N') AND
            (@V_IDCONSPARFIS <> 'N');

      SELECT @V_IDERROAVISO = MAX(IDERROAVISOFIL)
      FROM ERROAVISONFFIL
      WHERE CDERROAVISOFIL = 'AV10'
        AND CDFILIAL = @V_CDFILIORIG;

      IF @V_IDERROAVISO IS NULL BEGIN
         SELECT @V_IDERROAVISO = MAX(IDERROAVISO)
         FROM ERROAVISONF
         WHERE CDERROAVISO = 'AV10';
      END;

      UPDATE ITEMPRODUTO
      SET IDAVISOSITEM = SUBSTRING(IDAVISOSITEM,1,1) + '1' + SUBSTRING(IDAVISOSITEM,3,4)
      WHERE (CDFILIAL   = @P_CDFILIAL)   AND
            (NRLANCTONF = @P_NRLANCTONF) AND
            ((CDFISOPEITEM IS NULL) OR (DATALENGTH(CDFISOPEITEM) < 3)) AND
            (@V_IDERROAVISO <> 'N') AND
            (@V_IDCONSPARFIS <> 'N');

      IF NOT(@V_CDTIPOOPER = '07') BEGIN

         SELECT @V_IDERROAVISO = MAX(IDERROAVISOFIL)
         FROM ERROAVISONFFIL
         WHERE CDERROAVISOFIL = 'AV04'
           AND CDFILIAL = @V_CDFILIORIG;

         IF @V_IDERROAVISO IS NULL BEGIN
            SELECT @V_IDERROAVISO = MAX(IDERROAVISO)
            FROM ERROAVISONF
            WHERE CDERROAVISO = 'AV04';
         END;

         /* (AVISO) IMPOSTO DO ITEM DA ENTRADA COM CDIGO FISCAL INVLIDO */
         UPDATE TRABITPROIMPOS
         SET IDAVISIMPOIT = SUBSTRING(IDAVISIMPOIT,1,1) + '1' + SUBSTRING(IDAVISIMPOIT,3,3)
         WHERE (CDFILIMPOIT  = @P_CDFILIAL)   AND
               (NRLANCIMPOIT = @P_NRLANCTONF) AND
               ((CDFISCIMPOIT IS NULL) OR DATALENGTH(CDFISCIMPOIT) <> 1) AND
               (@V_IDERROAVISO <> 'N');

         SELECT @V_IDERROAVISO = MAX(IDERROAVISOFIL)
         FROM ERROAVISONFFIL
         WHERE CDERROAVISOFIL = 'AV05'
           AND CDFILIAL = @V_CDFILIORIG;

         IF @V_IDERROAVISO IS NULL BEGIN
            SELECT @V_IDERROAVISO = MAX(IDERROAVISO)
            FROM ERROAVISONF
            WHERE CDERROAVISO = 'AV05';
         END;

         /* (AVISO) IMPOSTO DO ITEM COM SITUAO TRIBUTRIA(CST) INVLIDA */
         UPDATE TRABITPROIMPOS
         SET IDAVISIMPOIT = SUBSTRING(IDAVISIMPOIT,1,2) + '1' + SUBSTRING(IDAVISIMPOIT,4,2)
         WHERE (CDFILIMPOIT  = @P_CDFILIAL)   AND
               (NRLANCIMPOIT = @P_NRLANCTONF) AND
               ((CDSTRIBIMPOIT IS NULL) OR (DATALENGTH(CDSTRIBIMPOIT) < 2)) AND
               (@V_IDERROAVISO <> 'N') AND
               (@V_IDCONSPARFIS <> 'N') AND
               (CDIMPOSTOIT IN(SELECT CDIMPOSTO
                                FROM IMPOSTO
                               WHERE IDCONSPARFISIP = 'S'));

         /* (AVISO) IMPOSTO DO ITEM COM CD. FISCAL OPERAO - CFOP INVLIDO */
         SELECT @V_IDERROAVISO = MAX(IDERROAVISOFIL)
         FROM ERROAVISONFFIL
         WHERE CDERROAVISOFIL = 'AV06'
           AND CDFILIAL = @V_CDFILIORIG;

         IF @V_IDERROAVISO IS NULL BEGIN
            SELECT @V_IDERROAVISO = MAX(IDERROAVISO)
            FROM ERROAVISONF
            WHERE CDERROAVISO = 'AV06';
         END;

         UPDATE TRABITPROIMPOS
         SET IDAVISIMPOIT = SUBSTRING(IDAVISIMPOIT,1,3) + '1' + SUBSTRING(IDAVISIMPOIT,5,1)
         WHERE (CDFILIMPOIT  = @P_CDFILIAL)   AND
               (NRLANCIMPOIT = @P_NRLANCTONF) AND
               ((CDFOPERIMPOIT IS NULL) OR (DATALENGTH(CDFOPERIMPOIT) < 3)) AND
               (@V_IDERROAVISO <> 'N') AND
               (@V_IDCONSPARFIS <> 'N') AND
               (CDIMPOSTOIT IN(SELECT CDIMPOSTO
                                FROM IMPOSTO
                               WHERE IDCONSPARFISIP = 'S'));
      END;
   END;

   IF @V_IDENTRSAID = 'E' BEGIN
      IF (@V_CDTIPOOPER NOT IN ('05', '07', '09', '10')) AND (NOT ((@V_IDNFGERADAVIAXML = 'S') AND (@V_IDGERNFIGUALXML = 'S'))) BEGIN /*NF COBRANCA, NF MOVIMENTACAO, VALE TRANSFERENCIA, ENTRADA S/ NOTA*/
         UPDATE TRABIMPOSNFTOT
         SET IDAVISOSTOT = '00',
             IDERROSTOT  = '0'
         WHERE CDFILIMPTOT  = @P_CDFILIAL AND
               NRLANCIMPTOT = @P_NRLANCTONF;

         SELECT @V_IDERROAVISO = MAX(IDERROAVISOFIL)
         FROM ERROAVISONFFIL
         WHERE CDERROAVISOFIL = 'AV02'
           AND CDFILIAL = @V_CDFILIORIG;

         IF @V_IDERROAVISO IS NULL BEGIN
            SELECT @V_IDERROAVISO = MAX(IDERROAVISO)
            FROM ERROAVISONF
            WHERE CDERROAVISO = 'AV02';
         END;

         IF @V_IDOPERDEVONF = 'S' BEGIN
            SELECT @V_DEVOLORIG = MAX(NRLANCTONF)
            FROM ITEMNOTAFISC
            WHERE CDFILIAL   = @P_CDFILIAL   AND
                  NRLANCTONF = @P_NRLANCTONF;
         END;

         /* (AVISO) PERCENTUAL DE ICMS DA TABELA DIFERE DO PERCENTUAL INFORMADO */

         UPDATE TRABITPROIMPOS
         SET IDAVISIMPOIT   = '1' + SUBSTRING(IDAVISIMPOIT,2,4)
         WHERE CDFILIMPOIT  = @P_CDFILIAL   AND
               NRLANCIMPOIT = @P_NRLANCTONF AND
               NRSEQITPRO   = '1'           AND
               @V_IDERROAVISO <> 'N'        AND
               @V_DEVOLORIG IS NULL         AND
               IDVALORINFO <> 'S'           AND
               --((@V_CDTIPOOPER = '03' AND VRALIQIMPOIT <> 0) OR
               (@V_CDTIPOOPER <> '03') AND
               CDIMPOSTOIT IN (SELECT CDIMPOSTO
                               FROM IMPOSTO
                               WHERE IDCONSISTENT = 'S' AND
                                     IDUTVLRQTDEIMPO <> 'S' AND
                               NOT EXISTS
                               (SELECT CDIMPOSTO
                                FROM IMPOSEMPRE
                                WHERE CDEMPRESA = @V_CDEMPRESA AND
                                      IDCONIMPENT = 'N')       AND
                               NOT EXISTS
                               (SELECT CDIMPOSTO
                                FROM IMPOSFORN
                                WHERE (CDFORNECED   = @V_CDFORNECED) AND
                                      ((IDIMPOSOPCI = 'S') AND (TRABITPROIMPOS.VRALIQIMPOIT = 0)))) AND
               @V_FAIXATOLER < (SELECT ABS(ISNULL(SUM(VRIMPOSTOIT),0) - TRABITPROIMPOS.VRIMPOSIT) AS VRDIFERENCA
                                FROM ITEMPROIMPOS
                                WHERE CDFILIAL     = @P_CDFILIAL    AND
                                      NRLANCTONF   = @P_NRLANCTONF  AND
                                      NRSEQITPROD  = TRABITPROIMPOS.NRSEQIMPOIT AND
                                      CDIMPOSTO    = TRABITPROIMPOS.CDIMPOSTOIT AND
                                      NRITPROIMPOS = '1');

         SELECT @V_IDERROAVISO = MAX(IDERROAVISOFIL)
         FROM ERROAVISONFFIL
         WHERE CDERROAVISOFIL = 'AV03'
           AND CDFILIAL = @V_CDFILIORIG;

         IF @V_IDERROAVISO IS NULL BEGIN
            SELECT @V_IDERROAVISO = MAX(IDERROAVISO)
            FROM ERROAVISONF
            WHERE CDERROAVISO = 'AV03';
         END;

         /*01/ (AVISO) PERCENTUAL ICMS DO ITEM DIFERE DO VALOR ICMS DO ITEM*/
         UPDATE TRABITPROIMPOS
         SET IDAVISIMPOIT = SUBSTRING(IDAVISIMPOIT,1,4) + '1'
         WHERE (CDFILIMPOIT  = @P_CDFILIAL)   AND
               (NRLANCIMPOIT = @P_NRLANCTONF) AND
               (NRSEQITPRO   = '1')          AND
               (@V_IDERROAVISO <> 'N')        AND
               --((@V_CDTIPOOPER = '03' AND VRALIQIMPOIT <> 0) OR
               (@V_CDTIPOOPER <> '03') AND
               (CDIMPOSTOIT IN (SELECT CDIMPOSTO
                                FROM IMPOSTO I
                                WHERE I.IDCONSISTENT = 'S'             AND
                                      ISNULL(I.IDUTVRMENSBC,'N') = 'N' AND
                                      IDUTVLRQTDEIMPO <> 'S'           AND
                                      NOT EXISTS(SELECT CDIMPOSTO
                                                 FROM IMPOSTO IMP
                                                 WHERE IMP.CDIMPOSTRIB  = I.CDIMPOSTO AND
                                                       IMP.IDVRIMPSTRIB = 'S')        AND
                                NOT EXISTS
                                (SELECT CDIMPOSTO
                                 FROM IMPOSEMPRE
                                 WHERE CDEMPRESA = @V_CDEMPRESA AND
                                       IDCONIMPENT = 'N'))) AND
               (@V_FAIXATOLER < ABS(ROUND((VRBCALCIMPOIT * (VRALIQIMPOIT/100)),2) - (VRIMPOSIT)));

         SELECT @V_IDERROAVISO = MAX(IDERROAVISOFIL)
         FROM ERROAVISONFFIL
         WHERE CDERROAVISOFIL = 'ER01'
           AND CDFILIAL = @V_CDFILIORIG;

         IF @V_IDERROAVISO IS NULL BEGIN
            SELECT @V_IDERROAVISO = MAX(IDERROAVISO)
            FROM ERROAVISONF
            WHERE CDERROAVISO = 'ER01';
         END;

          /* (ERRO) ICMS DA NF INVLIDO */
         UPDATE TRABIMPOSNFTOT
         SET IDERROSTOT = '1'
         WHERE CDFILIMPTOT  = @P_CDFILIAL    AND
               NRLANCIMPTOT = @P_NRLANCTONF  AND
               @V_IDERROAVISO <> 'N'         AND
               CDIMPOSTOT   IN (SELECT CDIMPOSTO
                                FROM IMPOSTO
                                WHERE IDPRODNOTA   = 'P'              AND
                                      ISNULL(IDUTVRMENSBC,'N') = 'N'  AND
                                      ISNULL(IDPREIMPENTR,'N') = 'N'  AND
                                      IDUTVLRQTDEIMPO <> 'S')         AND
               @V_FAIXATOLER <  (SELECT ABS(ROUND(SUM(VRIMPOSIT),@V_NRDECTOTANF) - TRABIMPOSNFTOT.VRIMPOSTOT) AS VRIMPOSIT
                                FROM TRABITPROIMPOS
                                WHERE CDFILIMPOIT  = @P_CDFILIAL                AND
                                      NRLANCIMPOIT = @P_NRLANCTONF              AND
                                      CDIMPOSTOIT  = TRABIMPOSNFTOT.CDIMPOSTOT AND
                                      NRSEQITPRO   = '1');

         SELECT @V_IDERROAVISO = MAX(IDERROAVISOFIL)
         FROM ERROAVISONFFIL
         WHERE CDERROAVISOFIL = 'AV07'
           AND CDFILIAL = @V_CDFILIORIG;

         IF @V_IDERROAVISO IS NULL BEGIN
            SELECT @V_IDERROAVISO = MAX(IDERROAVISO)
            FROM ERROAVISONF
            WHERE CDERROAVISO = 'AV07';
         END;

         /* (AVISO) VALOR DE INSS INFORMADO DIFERENTE DA TABELA */
         UPDATE TRABIMPOSNFTOT
         SET IDAVISOSTOT = '10'
         WHERE CDFILIMPTOT  = @P_CDFILIAL    AND
               NRLANCIMPTOT = @P_NRLANCTONF  AND
               @V_IDERROAVISO <> 'N'         AND
               --((@V_CDTIPOOPER = '03' AND VRIMPOSTOT <> 0) OR
               (@V_CDTIPOOPER <> '03') AND
               CDIMPOSTOT IN  (SELECT CDIMPOSTO
                               FROM IMPOSTO
                               WHERE IDCONSISTENT = 'S' AND
                                     IDPRODNOTA   = 'C') AND

                               NOT EXISTS(

                               SELECT CDIMPOSTO
                               FROM IMPOSEMPRE
                               WHERE CDEMPRESA   = @V_CDEMPRESA AND
                                     IDCONIMPENT = 'N') AND

                               NOT EXISTS(

                               SELECT CDIMPOSTO
                               FROM IMPOSFORN
                               WHERE (CDFORNECED = @V_CDFORNECED)) AND

               @V_FAIXATOLER < (SELECT ABS(ROUND(SUM(ISNULL(VRTOTIMPONF,0)),@V_NRDECTOTANF) - TRABIMPOSNFTOT.VRIMPOSTOT) AS VRTOTIMPONF
                                FROM IMPOSNFTOT
                                WHERE CDFILIAL   = @P_CDFILIAL    AND
                                      NRLANCTONF = @P_NRLANCTONF  AND
                                      CDIMPOSTO  = TRABIMPOSNFTOT.CDIMPOSTOT);

         SELECT @V_IDERROAVISO = MAX(IDERROAVISOFIL)
         FROM ERROAVISONFFIL
         WHERE CDERROAVISOFIL = 'AV08'
           AND CDFILIAL = @V_CDFILIORIG;

         IF @V_IDERROAVISO IS NULL BEGIN
            SELECT @V_IDERROAVISO = MAX(IDERROAVISO)
            FROM ERROAVISONF
            WHERE CDERROAVISO = 'AV08';
         END;

         UPDATE TRABIMPOSNFTOT
         SET IDAVISOSTOT = '01'
         WHERE CDFILIMPTOT  = @P_CDFILIAL    AND
               NRLANCIMPTOT = @P_NRLANCTONF  AND
               @V_IDERROAVISO <> 'N'         AND
               --((@V_CDTIPOOPER = '03' AND VRIMPOSTOT <> 0) OR
               (@V_CDTIPOOPER <> '03') AND
               CDIMPOSTOT IN  (SELECT CDIMPOSTO
                               FROM IMPOSTO
                               WHERE IDCONSISTENT = 'S' AND
                                     IDPRODNOTA   = 'C' AND

                               EXISTS(

                               SELECT CDIMPOSTO
                               FROM IMPOSFORN
                               WHERE (CDFORNECED   = @V_CDFORNECED) AND
                                     (IDIMPOSOPCI =  'S' AND TRABIMPOSNFTOT.VRIMPOSTOT = 0) OR
                                      IDIMPOSOPCI <> 'S') AND

                               NOT EXISTS(

                               SELECT CDIMPOSTO
                               FROM IMPOSEMPRE
                               WHERE CDEMPRESA = @V_CDEMPRESA AND
                                     IDCONIMPENT = 'N')) AND

               @V_FAIXATOLER <  (SELECT ABS(SUM(VRTOTIMPONF) - TRABIMPOSNFTOT.VRIMPOSTOT) AS VRTOTIMPONF
                                FROM IMPOSNFTOT
                                WHERE CDFILIAL   = @P_CDFILIAL    AND
                                      NRLANCTONF = @P_NRLANCTONF  AND
                                      CDIMPOSTO  = TRABIMPOSNFTOT.CDIMPOSTOT);
      END;
      UPDATE NOTAFISCAL
      SET IDERROS  = '0000',
          IDAVISOS = '00000'
      WHERE CDFILIAL   =  @P_CDFILIAL AND
            NRLANCTONF =  @P_NRLANCTONF;

      IF (@V_CDTIPOOPER = '05') AND (NOT ((@V_IDNFGERADAVIAXML = 'S') AND (@V_IDGERNFIGUALXML = 'S'))) BEGIN
         SELECT @V_IDERROAVISO = MAX(IDERROAVISOFIL)
         FROM ERROAVISONFFIL
         WHERE CDERROAVISOFIL = 'ER02'
           AND CDFILIAL = @V_CDFILIORIG;

         IF @V_IDERROAVISO IS NULL BEGIN
            SELECT @V_IDERROAVISO = MAX(IDERROAVISO)
            FROM ERROAVISONF
            WHERE CDERROAVISO = 'ER02';
         END;

         /* (ERRO) TOTAL NOTA FISCAL DIFERE SOMA DOS ITEMS */

         SELECT @V_VRNOTAFISC = ROUND(SUM(N.VRNOTAFISC),2)
         FROM ITEMNOTAFISC I, NOTAFISCAL N
         WHERE I.CDFILIAL   = @P_CDFILIAL    AND
               I.NRLANCTONF = @P_NRLANCTONF  AND
               N.CDFILIAL   = I.CDFILIALIT  AND
               N.NRLANCTONF = I.NRLANCTONFIT;


         SET @V_PERCDIF = @P_VRLANCAMENTO - @V_VRNOTAFISC;

         IF (@V_FAIXATOLER = 0 OR @V_FAIXATOLER IS NULL) AND (@V_PERCDIF <> 0) BEGIN
            UPDATE NOTAFISCAL
            SET IDERROS = '1010'
            WHERE CDFILIAL   =  @P_CDFILIAL    AND
                  NRLANCTONF =  @P_NRLANCTONF  AND
                  @V_IDERROAVISO <> 'N';
         END
         ELSE BEGIN
            SET @V_VALRMAX = (@V_VRNOTAFISC + @V_FAIXATOLER);
            SET @V_VALRMIN = (@V_VRNOTAFISC - @V_FAIXATOLER);

            IF (@V_VALRMIN > @P_VRLANCAMENTO) OR (@V_VALRMAX < @P_VRLANCAMENTO) BEGIN
               UPDATE NOTAFISCAL
               SET IDERROS = '1010'
               WHERE CDFILIAL   =  @P_CDFILIAL    AND
                     NRLANCTONF =  @P_NRLANCTONF  AND
                     @V_IDERROAVISO <> 'N';
            END;
         END;
      END
      ELSE BEGIN
         IF NOT ((@V_IDNFGERADAVIAXML = 'S') AND (@V_IDGERNFIGUALXML = 'S')) BEGIN
            IF @V_CDTIPOOPER = '11'  BEGIN
               SELECT @V_IDERROAVISO = MAX(IDERROAVISOFIL)
               FROM ERROAVISONFFIL
               WHERE CDERROAVISOFIL = 'ER05'
                 AND CDFILIAL = @V_CDFILIORIG;

               IF @V_IDERROAVISO IS NULL BEGIN
                  SELECT @V_IDERROAVISO = MAX(IDERROAVISO)
                  FROM ERROAVISONF
                  WHERE CDERROAVISO = 'ER05';
               END;

               SELECT @V_VRSOMAENCA = ISNULL(SUM(VRITEMENCA),0)
                 FROM ITEMENCARGO I, ENCARGO E
                WHERE I.CDFILIAL   = @P_CDFILIAL
                  AND I.NRLANCTONF = @P_NRLANCTONF
                  AND I.CDENCARGO  = E.CDENCARGO
                  AND E.IDENCARGO = 'A';

               SELECT @V_VRMENOENCA = ISNULL(SUM(VRITEMENCA),0)
                 FROM ITEMENCARGO I, ENCARGO E
                WHERE I.CDFILIAL   = @P_CDFILIAL
                  AND I.NRLANCTONF = @P_NRLANCTONF
                  AND I.CDENCARGO  = E.CDENCARGO
                  AND E.IDENCARGO = 'D';

               SELECT @V_VRSOMAIMPO = ISNULL(SUM(VRIMPOSTOIT),0)
                 FROM ITEMPROIMPOS NF, IMPOSTO IP
                WHERE NF.CDFILIAL   = @P_CDFILIAL
                  AND NF.NRLANCTONF = @P_NRLANCTONF
                  AND NF.CDIMPOSTO = IP.CDIMPOSTO
                  AND IP.IDTRATIMPO = 'A';

               SELECT @V_VRMENOIMPO = ISNULL(SUM(VRIMPOSTOIT),0)
                 FROM ITEMPROIMPOS NF, IMPOSTO IP
                WHERE NF.CDFILIAL   = @P_CDFILIAL
                  AND NF.NRLANCTONF = @P_NRLANCTONF
                  AND NF.CDIMPOSTO = IP.CDIMPOSTO
                  AND IP.IDTRATIMPO = 'D';

               UPDATE NOTAFISCAL
               SET IDERROS = '1100'
               WHERE CDFILIAL   =  @P_CDFILIAL    AND
                     NRLANCTONF =  @P_NRLANCTONF  AND
                     @V_IDERROAVISO <> 'N'        AND
                     @V_FAIXATOLER < (SELECT ABS((NOTAFISCAL.VRNOTAFISC - (SUM(N.VRPRODUTOS) + @V_VRSOMAENCA - @V_VRMENOENCA + @V_VRSOMAIMPO - @V_VRMENOIMPO)))
                                        FROM (SELECT N.CDFILIAL, N.NRLANCTONF, ROUND(SUM(N.VRPRODUTOS),@V_NRDECTOTANF) AS VRPRODUTOS
                                                FROM ITEMNOTAFISC I, NOTAFISCAL N
                                               WHERE I.CDFILIAL   = @P_CDFILIAL    AND
                                                     I.NRLANCTONF = @P_NRLANCTONF  AND
                                                     N.CDFILIAL   = I.CDFILIALIT   AND
                                                     N.NRLANCTONF = I.NRLANCTONFIT
                                               GROUP BY N.CDFILIAL, N.NRLANCTONF) N);
            END;
         END;

         SELECT @V_IDERROAVISO = MAX(IDERROAVISOFIL)
         FROM ERROAVISONFFIL
         WHERE CDERROAVISOFIL = 'ER02'
           AND CDFILIAL = @V_CDFILIORIG;

         IF @V_IDERROAVISO IS NULL BEGIN
            SELECT @V_IDERROAVISO = MAX(IDERROAVISO)
            FROM ERROAVISONF
            WHERE CDERROAVISO = 'ER02';
         END;

         /* (ERRO) TOTAL NOTA FISCAL DIFERE SOMA DOS ITEMS */

         IF (@V_IDOPERDEVONF <> 'S') OR ((@V_IDOPERDEVONF = 'S') AND (@V_DEVOLORIG IS NULL)) BEGIN
            UPDATE NOTAFISCAL
            SET IDERROS = '1'+SUBSTRING(IDERROS,2,1)+'1'+SUBSTRING(IDERROS,4,1)
            WHERE CDFILIAL   =  @P_CDFILIAL    AND
                  NRLANCTONF =  @P_NRLANCTONF  AND
                  @V_IDERROAVISO <> 'N'        AND
                  @V_FAIXATOLER < ABS(ROUND(VRNOTAFISC,@V_NRDECTOTANF) - ROUND(@P_VRLANCAMENTO,@V_NRDECTOTANF));
         END
         ELSE BEGIN
            UPDATE NOTAFISCAL
            SET VRNOTAFISC = @P_VRLANCAMENTO
            WHERE CDFILIAL   =  @P_CDFILIAL    AND
                  NRLANCTONF =  @P_NRLANCTONF;
         END;
      END;

      IF (@V_CDTIPOOPER NOT IN ('02','04','06','07','09')) AND (@V_IDORIGDEST = 'F') AND (NOT ((@V_IDNFGERADAVIAXML = 'S') AND (@V_IDGERNFIGUALXML = 'S'))) BEGIN
         /* (ERRO) TOTAL DE VENCIMENTOS DIFERE VALOR TOTAL NOTA FISCAL */
         SELECT @V_IDERROAVISO = MAX(IDERROAVISOFIL)
         FROM ERROAVISONFFIL
         WHERE CDERROAVISOFIL = 'ER03'
           AND CDFILIAL = @V_CDFILIORIG;

         IF @V_IDERROAVISO IS NULL BEGIN
            SELECT @V_IDERROAVISO = MAX(IDERROAVISO)
            FROM ERROAVISONF
            WHERE CDERROAVISO = 'ER03';
         END;

         SELECT @V_VRIMPOSTOT = ROUND(ISNULL(SUM(T.VRIMPOSTOT),0),@V_NRDECTOTANF)
         FROM TRABIMPOSNFTOT T, IMPOSTO I
         WHERE T.CDFILIMPTOT  = @P_CDFILIAL    AND
               T.NRLANCIMPTOT = @P_NRLANCTONF  AND
               T.CDIMPOSTOT   = I.CDIMPOSTO    AND
               @V_IDERROAVISO <> 'N'           AND
               I.IDTRATIMPO   = 'R'            AND
               I.IDDESCRFONTE = 'R';

         /* Verifica o valor bruto dos itens que no iro compor o vencimento da nota fiscal */
         SELECT @V_VRSUBTRAIVENC = ISNULL(SUM(VRBRUTITEM),0)
           FROM ITEMPRODUTO IT, TPOPERCFOP T
          WHERE IT.CDFILIAL    = @P_CDFILIAL
            AND IT.NRLANCTONF  = @P_NRLANCTONF
            AND T.IDENTRSAIDOP = @V_IDENTRSAID
            AND T.CDTIPOOPER   = @V_CDTIPOOPER
            AND T.IDCOMPOEVENC = 'N'
            AND T.CDFISCOPER   = IT.CDFISOPEITEM;

         IF @V_CDTIPOOPER <> '08' BEGIN
            UPDATE NOTAFISCAL
            SET IDERROS = '1' + SUBSTRING(IDERROS,2,2) + '1'
            WHERE CDFILIAL   =  @P_CDFILIAL    AND
                  NRLANCTONF =  @P_NRLANCTONF  AND
                  @V_FAIXATOLER < (SELECT ABS(ISNULL(SUM(VRORIGPAG),(NOTAFISCAL.VRNOTAFISC - @V_VRIMPOSTOT - @V_VRSUBTRAIVENC)) - (NOTAFISCAL.VRNOTAFISC - @V_VRIMPOSTOT - @V_VRSUBTRAIVENC))
                                  FROM CONTAPAGAR
                                  WHERE CDFILIAL   =  @P_CDFILIAL    AND
                                        NRLANCTONF =  @P_NRLANCTONF );
         END;

         /* (AVISO) Data de Vencimento informada anterior  data de processamento.*/
         SELECT @V_IDERROAVISO = MAX(IDERROAVISOFIL)
         FROM ERROAVISONFFIL
         WHERE CDERROAVISOFIL = 'AV17'
           AND CDFILIAL = @V_CDFILIORIG;

         IF @V_IDERROAVISO IS NULL BEGIN
            SELECT @V_IDERROAVISO = MAX(IDERROAVISO)
            FROM ERROAVISONF
            WHERE CDERROAVISO = 'AV17';
         END;

         UPDATE NOTAFISCAL
            SET IDAVISOS       =  SUBSTRING(IDAVISOS,1,4) + '1'
          WHERE CDFILIAL       =  @P_CDFILIAL    AND
                NRLANCTONF     =  @P_NRLANCTONF  AND
                @V_IDERROAVISO <> 'N'           AND
                (SELECT CASE @V_IDUTILDTPROC WHEN 'S' THEN ISNULL(DTPROCESSA,CONVERT(DATETIME, GETDATE())) ELSE  DTPROCESSA  END
                   FROM PARAMFILIAL
                  WHERE CDFILIAL = @V_CDFILIORIG) > (SELECT MIN(DTORIGVENPAG)
                                                       FROM CONTAPAGAR
                                                      WHERE CDFILIAL   =  @P_CDFILIAL    AND
                                                            NRLANCTONF =  @P_NRLANCTONF);
      END;

      IF NOT @V_NRAUTOFORN IS NULL BEGIN
         /* (AVISO) DATA DE VENCIMENTO DA NOTA FISCAL DIFERE DA DATA DE PROGRAMADA NA AF */

         SELECT @V_IDERROAVISO = MAX(IDERROAVISOFIL)
         FROM ERROAVISONFFIL
         WHERE CDERROAVISOFIL = 'AV15'
           AND CDFILIAL = @V_CDFILIORIG;

         IF @V_IDERROAVISO IS NULL BEGIN
            SELECT @V_IDERROAVISO = MAX(IDERROAVISO)
            FROM ERROAVISONF
            WHERE CDERROAVISO = 'AV15';
         END;

         SELECT @V_NRORIGVENPAG = MAX(QTDIASVENPAG)
         FROM CONTAPAGAR
         WHERE NRSEQVENPAG = '01'           AND
               CDFILIAL   =  @P_CDFILIAL     AND
               NRLANCTONF =  @P_NRLANCTONF;

         SELECT @V_IDTIPODTPGTO = MAX(FORMPGTO.IDTIPODTPGTO)
         FROM AUTOFORNE, FORMPGTO
         WHERE AUTOFORNE.CDFILDEST  = @V_CDFILDEST   AND
               AUTOFORNE.CDFILLANC  = @V_CDFILLANC   AND
               AUTOFORNE.NRAUTOFORN = @V_NRAUTOFORN  AND
               AUTOFORNE.CDFORMPGTO = FORMPGTO.CDFORMPGTO;

         IF NOT(@V_IDTIPODTPGTO IN ('EMIN','ENIN','UEMI')) BEGIN
            UPDATE NOTAFISCAL
            SET IDAVISOS = '1' + SUBSTRING(IDAVISOS,2,2)+ '1' + SUBSTRING(IDERROS,5,1)
            WHERE CDFILIAL       =  @P_CDFILIAL     AND
                  NRLANCTONF     =  @P_NRLANCTONF   AND
                  @V_NRORIGVENPAG <> (SELECT MIN(C.NRDIASPGTOAF)
                                     FROM PRAZOPGTAF C, ITEMAUTF I
                                     WHERE I.CDFILLANC   = C.CDFILLANC   AND
                                           I.CDFILDEST   = C.CDFILDEST   AND
                                           I.NRAUTOFORN  = C.NRAUTOFORN  AND
                                           I.CDFILLANC   = @V_CDFILLANC   AND
                                           I.CDFILDEST   = @V_CDFILDEST   AND
                                           I.NRAUTOFORN  = @V_NRAUTOFORN) AND
                  @V_IDERROAVISO <> 'N';
         END;

         IF (@V_IDTIPODTPGTO IN ('EMIN','ENIN','UEMI')) BEGIN
            UPDATE NOTAFISCAL
            SET IDAVISOS = '1' + SUBSTRING(IDAVISOS,2,2)+ '1' + SUBSTRING(IDERROS,5,1)
            WHERE CDFILIAL       =  @P_CDFILIAL     AND
                  NRLANCTONF     =  @P_NRLANCTONF   AND
                  @V_NRORIGVENPAG <> (SELECT MIN(C.NRDIASPGTOAF)-1
                                     FROM PRAZOPGTAF C, ITEMAUTF I
                                     WHERE I.CDFILLANC   = C.CDFILLANC   AND
                                           I.CDFILDEST   = C.CDFILDEST   AND
                                           I.NRAUTOFORN  = C.NRAUTOFORN  AND
                                           I.CDFILLANC   = @V_CDFILLANC   AND
                                           I.CDFILDEST   = @V_CDFILDEST   AND
                                           I.NRAUTOFORN  = @V_NRAUTOFORN) AND
                  @V_IDERROAVISO <> 'N';
         END;

         /* (AVISO) DATA DE ENTRADA DA NOTA FISCAL DIFERE DA DATA DE PROGRAMADA NA AF */
         SELECT @V_IDERROAVISO = MAX(IDERROAVISOFIL)
         FROM ERROAVISONFFIL
         WHERE CDERROAVISOFIL = 'AV12'
           AND CDFILIAL = @V_CDFILIORIG;

         IF @V_IDERROAVISO IS NULL BEGIN
            SELECT @V_IDERROAVISO = MAX(IDERROAVISO)
            FROM ERROAVISONF
            WHERE CDERROAVISO = 'AV12';
         END;

         UPDATE NOTAFISCAL
         SET IDAVISOS = '11' + SUBSTRING(IDAVISOS,3,3)
         WHERE CDFILIAL   =  @P_CDFILIAL    AND
               NRLANCTONF =  @P_NRLANCTONF  AND
               DTENTRSAID <> @V_DTPROGENTAF AND
               @V_IDERROAVISO <> 'N';

         /* Se no estiver sendo utilizado fornecedor relacionado para a AF  */
         IF @V_IDUTRELACFORNAF <> 'S' BEGIN
            /* (AVISO) FORNECEDOR DA NOTA FISCAL DIFERE DO FORNECEDOR DA AF */
            SELECT @V_IDERROAVISO = MAX(IDERROAVISOFIL)
            FROM ERROAVISONFFIL
            WHERE CDERROAVISOFIL = 'AV01'
              AND CDFILIAL = @V_CDFILIORIG;

            IF @V_IDERROAVISO IS NULL BEGIN
               SELECT @V_IDERROAVISO = MAX(IDERROAVISO)
               FROM ERROAVISONF
               WHERE CDERROAVISO = 'AV01';
            END;

            UPDATE NOTAFISCAL
            SET IDAVISOS = '1' + SUBSTRING(IDAVISOS,2,1) + '1' + SUBSTRING(IDAVISOS,4,2)
            WHERE CDFILIAL   =  @P_CDFILIAL    AND
                  NRLANCTONF =  @P_NRLANCTONF  AND
                  @V_IDERROAVISO <> 'N'        AND
                  CDFORNECED <> (SELECT MAX(CDFORNECED)
                                 FROM AUTOFORNE AF
                                 WHERE (AF.CDFILDEST     = @V_CDFILDEST)  AND
                                       (AF.CDFILLANC     = @V_CDFILLANC)  AND
                                       (AF.NRAUTOFORN    = @V_NRAUTOFORN));
         END
         ELSE BEGIN
            /* (AVISO) FORNECEDOR DA NOTA FISCAL DIFERE DO FORNECEDOR DA AF */
            SELECT @V_IDERROAVISO = MAX(IDERROAVISOFIL)
            FROM ERROAVISONFFIL
            WHERE CDERROAVISOFIL = 'AV01'
              AND CDFILIAL = @V_CDFILIORIG;

            IF @V_IDERROAVISO IS NULL BEGIN
               SELECT @V_IDERROAVISO = MAX(IDERROAVISO)
               FROM ERROAVISONF
               WHERE CDERROAVISO = 'AV01';
            END;

            UPDATE NOTAFISCAL
            SET IDAVISOS = '1' + SUBSTRING(IDAVISOS,2,1) + '1' + SUBSTRING(IDAVISOS,4,2)
            WHERE CDFILIAL   =  @P_CDFILIAL    AND
                  NRLANCTONF =  @P_NRLANCTONF  AND
                  @V_IDERROAVISO <> 'N'        AND
                  CDFORNECED NOT IN (SELECT CDFORNECED
                                     FROM AUTOFORNE AF
                                     WHERE (AF.CDFILDEST  = @V_CDFILDEST)  AND
                                           (AF.CDFILLANC  = @V_CDFILLANC)  AND
                                           (AF.NRAUTOFORN = @V_NRAUTOFORN)
                                     UNION
                                     SELECT N.CDFORNECED
                                     FROM
                                        NOTAFISCAL N, FORNECEDOR F, AUTOFORNE AF
                                     WHERE
                                        (N.CDFILIAL    = @P_CDFILIAL)      AND
                                        (N.NRLANCTONF  = @P_NRLANCTONF)    AND
                                        (N.CDFORNECED  = F.CDFORNECED)     AND
                                        (AF.CDFILDEST  = @V_CDFILDEST)     AND
                                        (AF.CDFILLANC  = @V_CDFILLANC)     AND
                                        (AF.NRAUTOFORN = @V_NRAUTOFORN)    AND
                                        (AF.CDFORNECED = F.CDFORNERELAC)
                                     UNION
                                     SELECT N.CDFORNECED
                                     FROM
                                        NOTAFISCAL N, FORNECEDOR F, AUTOFORNE AF, FORNECEDOR FR
                                     WHERE
                                        (N.CDFILIAL     = @P_CDFILIAL)      AND
                                        (N.NRLANCTONF   = @P_NRLANCTONF)    AND
                                        (N.CDFORNECED   = FR.CDFORNECED)    AND
                                        (AF.CDFILDEST   = @V_CDFILDEST)     AND
                                        (AF.CDFILLANC   = @V_CDFILLANC)     AND
                                        (AF.NRAUTOFORN  = @V_NRAUTOFORN)    AND
                                        (AF.CDFORNECED  = F.CDFORNECED)     AND
                                        (NOT F.CDFORNERELAC IS NULL)        AND
                                        (F.CDFORNERELAC = FR.CDFORNERELAC)
                                     UNION
                                     SELECT F.CDFORNERELAC AS CDFORNECED
                                     FROM
                                        AUTOFORNE AF, FORNECEDOR F
                                     WHERE (AF.CDFILDEST  = @V_CDFILDEST)   AND
                                           (AF.CDFILLANC  = @V_CDFILLANC)   AND
                                           (AF.NRAUTOFORN = @V_NRAUTOFORN)  AND
                                           (AF.CDFORNECED = F.CDFORNECED)   AND
                                           (NOT F.CDFORNERELAC IS NULL));
         END;

         SELECT @V_IDCONVRUNIAF = MAX(IDERROAVISOFIL)
         FROM ERROAVISONFFIL
         WHERE CDERROAVISOFIL = 'AV13'
           AND CDFILIAL = @V_CDFILIORIG;

         IF @V_IDCONVRUNIAF IS NULL BEGIN
            SELECT @V_IDCONVRUNIAF = MAX(IDERROAVISO)
            FROM ERROAVISONF
            WHERE CDERROAVISO = 'AV13';
         END;

         SELECT @V_IDCONQTDEAF = MAX(IDERROAVISOFIL)
         FROM ERROAVISONFFIL
         WHERE CDERROAVISOFIL = 'AV11'
           AND CDFILIAL = @V_CDFILIORIG;

         IF @V_IDCONQTDEAF IS NULL BEGIN
            SELECT @V_IDCONQTDEAF = MAX(IDERROAVISO)
            FROM ERROAVISONF
            WHERE CDERROAVISO = 'AV11';
         END;

         SELECT @V_IDCONQTDEREC = MAX(IDERROAVISOFIL)
         FROM ERROAVISONFFIL
         WHERE CDERROAVISOFIL = 'AV14'
           AND CDFILIAL = @V_CDFILIORIG;

         IF @V_IDCONQTDEREC IS NULL BEGIN
            SELECT @V_IDCONQTDEREC = MAX(IDERROAVISO)
            FROM ERROAVISONF
            WHERE CDERROAVISO = 'AV14';
         END;

         SELECT @V_IDPRODNFAF = MAX(IDERROAVISOFIL)
         FROM ERROAVISONFFIL
         WHERE CDERROAVISOFIL = 'AV16'
           AND CDFILIAL = @V_CDFILIORIG;

         IF @V_IDPRODNFAF IS NULL BEGIN
            SELECT @V_IDPRODNFAF = MAX(IDERROAVISO)
            FROM ERROAVISONF
            WHERE CDERROAVISO = 'AV16';
         END;

         DECLARE C_ITEMAF CURSOR FOR
         SELECT CASE N.IDENTRSAIDOP WHEN 'E' THEN N.CDFILIRECE ELSE N.CDFILIEMIT END AS CDFILIORIG,
                I.NRSEQITPROD, I.CDFILDEST, I.CDFILIAL, I.NRAUTOFORN, I.CDPRODUTO, I.CDMARCA, I.DTPROGENTAF
         FROM ITEMPRODUTO I, NOTAFISCAL N
         WHERE N.CDFILIAL   = @P_CDFILIAL AND
               N.NRLANCTONF = @P_NRLANCTONF AND
               N.CDFILIAL   = I.CDFILIAL   AND
               N.NRLANCTONF = I.NRLANCTONF;

         OPEN C_ITEMAF;

         FETCH NEXT FROM C_ITEMAF INTO @V_CDFILIORIG,@V_NRSEQITPROD, @V_CDFILDEST, @V_CDFILLANC, @V_NRAUTOFORN, @V_CDPRODUTO, @V_CDMARCA, @V_DTPROGENTAF;

         WHILE (@@FETCH_STATUS = 0) BEGIN

            SELECT @V_VRPTOLQTITAF = MAX(VRPTOLQTITAF),
                   @V_VRPTOLVRITAF = MAX(VRPTOLVRITAF)
            FROM PRODFILI F
            WHERE F.CDFILIAL  = @V_CDFILIORIG  AND
                  F.CDPRODUTO = @V_CDPRODUTO;

            IF @V_VRPTOLQTITAF IS NULL BEGIN
               SET @V_VRPTOLQTITAF = ISNULL(@V_VRPETOLEQTAF, 0.00);
            END;

            IF @V_VRPTOLVRITAF IS NULL BEGIN
               SET @V_VRPTOLVRITAF = ISNULL(@V_VRPETOLEVRAF,0.00);
            END;

            /* (AVISO) QUANTIDADE DE PRODUTO INFORMADA DIFERE DA QUANTIDADE PREVISTA NA AF */
            SELECT @V_QTNFRELACAF = SUM(QTNFRELACAF)
            FROM NFRELACAF N, ITEMAUTF I
            WHERE (N.CDFILIAL    = @P_CDFILIAL)   AND
                  (N.NRLANCTONF  = @P_NRLANCTONF) AND
                  (N.CDFILDEST   = I.CDFILDEST)   AND
                  (N.CDFILLANC   = I.CDFILLANC)   AND
                  (N.NRAUTOFORN  = I.NRAUTOFORN)  AND
                  (N.CDMARCA     = I.CDMARCA)     AND
                  (N.CDPRODUTO   = I.CDPRODUTO)   AND
                  (N.DTPROGENTAF = I.DTPROGENTAF) AND
                  (N.CDPRODUTO   = @V_CDPRODUTO)  AND
                  (N.CDMARCA     = @V_CDMARCA);

            SELECT @V_QTITEMPROD = SUM(QTITEMPROD)
            FROM ITEMPRODUTO
            WHERE (CDFILIAL   = @P_CDFILIAL)   AND
                  (NRLANCTONF = @P_NRLANCTONF) AND
                  (CDPRODUTO  = @V_CDPRODUTO)  AND
                  (CDMARCA    = @V_CDMARCA);

           UPDATE ITEMPRODUTO
            SET IDAVISOSITEM = SUBSTRING(IDAVISOSITEM,1,2) + '1' + SUBSTRING(IDAVISOSITEM,4,3)
            WHERE (CDFILIAL    = @P_CDFILIAL   ) AND
                  (NRLANCTONF  = @P_NRLANCTONF ) AND
                  (NRSEQITPROD = @V_NRSEQITPROD) AND
                  ((@V_QTITEMPROD  > (@V_QTNFRELACAF + ((ROUND(@V_QTNFRELACAF,3) * @V_VRPTOLQTITAF)/100))) OR
                   ((@V_QTITEMPROD < (@V_QTNFRELACAF - ((ROUND(@V_QTNFRELACAF,3) * @V_VRPTOLQTITAF)/100))) AND
                    (@V_IDCONSVLRMAF) = 'S')) AND
                  (@V_IDCONQTDEAF <> 'N');

            /* (AVISO) VALOR UNITRIO DO PRODUTO DIFERE DO VALOR UNITRIO PREVISTO NA AF */
            SELECT @V_VRNFRELACAF = MAX(VRNFRELACAF)
            FROM NFRELACAF N
            WHERE (N.CDFILIAL    = @P_CDFILIAL   ) AND
                  (N.NRLANCTONF  = @P_NRLANCTONF ) AND
                  (N.NRAUTOFORN  = @V_NRAUTOFORN ) AND
                  (N.CDPRODUTO   = @V_CDPRODUTO  ) AND
                  (N.CDMARCA     = @V_CDMARCA    ) AND
                  (N.DTPROGENTAF = @V_DTPROGENTAF);


            UPDATE ITEMPRODUTO
            SET  IDAVISOSITEM = SUBSTRING(IDAVISOSITEM,1,3)+ '1' + SUBSTRING(IDAVISOSITEM,5,2)
            WHERE (CDFILIAL    = @P_CDFILIAL   ) AND
                  (NRLANCTONF  = @P_NRLANCTONF ) AND
                  (NRSEQITPROD = @V_NRSEQITPROD) AND
                  ((ROUND(VRUNITITEM,2) > (ROUND(@V_VRNFRELACAF,2) + ((ROUND(@V_VRNFRELACAF,2) * @V_VRPTOLVRITAF)/100))) OR
                   ((ROUND(VRUNITITEM,2) < (ROUND(@V_VRNFRELACAF,2) - ((ROUND(@V_VRNFRELACAF,2) * @V_VRPTOLVRITAF)/100))) AND (@V_IDCONSVLRMENAF = 'N'))) AND
                  (@V_IDCONVRUNIAF <> 'N');

            /* (AVISO) QUANTIDADE DE PRODUTO INFORMADA DIFERE DA QUANTIDADE RECEBIDA */
            SELECT @V_QTENTRMERC = SUM(QTENTRMERC)
            FROM NFRELACAF N,
                 ITEMAUTF I LEFT JOIN
                 (SELECT R.CDFILDEST, R.CDFILLANC, R.NRAUTOFORN, E.CDMARCA,
                         E.CDPRODUTO, R.DTPROGENTRE, E.QTENTRMERC
                  FROM NFRELACAF NF, RELACENTRAF R, ITEMENTREGA E
                  WHERE NF.CDFILIAL   = @P_CDFILIAL    AND
                        NF.NRLANCTONF = @P_NRLANCTONF  AND
                        NF.CDFILDEST  = R.CDFILDEST    AND
                        NF.CDFILLANC  = R.CDFILLANC    AND
                        NF.NRAUTOFORN = R.NRAUTOFORN   AND
                        R.CDFILIAL    = E.CDFILIAL     AND
                        R.NRENTREGA   = E.NRENTREGA) EN ON
                                  (EN.CDFILDEST   = I.CDFILDEST  ) AND
                                  (EN.CDFILLANC   = I.CDFILLANC  ) AND
                                  (EN.NRAUTOFORN  = I.NRAUTOFORN ) AND
                                  (EN.CDMARCA     = I.CDMARCA    ) AND
                                  (EN.CDPRODUTO   = I.CDPRODUTO  ) AND
                                  (EN.DTPROGENTRE = I.DTPROGENTAF)

            WHERE (N.CDFILIAL    = @P_CDFILIAL  ) AND
                  (N.NRLANCTONF  = @P_NRLANCTONF) AND
                  (N.CDFILDEST   = I.CDFILDEST  ) AND
                  (N.CDFILLANC   = I.CDFILLANC  ) AND
                  (N.NRAUTOFORN  = I.NRAUTOFORN ) AND
                  (N.CDMARCA     = I.CDMARCA    ) AND
                  (N.CDPRODUTO   = I.CDPRODUTO  ) AND
                  (N.DTPROGENTAF = I.DTPROGENTAF) AND
                  (N.CDPRODUTO   = @V_CDPRODUTO)   AND
                  (N.CDMARCA     = @V_CDMARCA);

            SELECT @V_QTITEMPROD = SUM(QTITEMPROD)
            FROM ITEMPRODUTO
            WHERE (CDFILIAL   = @P_CDFILIAL  ) AND
                  (NRLANCTONF = @P_NRLANCTONF) AND
                  (CDPRODUTO  = @V_CDPRODUTO ) AND
                  (CDMARCA    = @V_CDMARCA   );

            UPDATE ITEMPRODUTO
            SET IDAVISOSITEM = SUBSTRING(IDAVISOSITEM,1,4) + '1' + SUBSTRING(IDAVISOSITEM,1,1)
            WHERE (CDFILIAL    = @P_CDFILIAL   ) AND
                  (NRLANCTONF  = @P_NRLANCTONF ) AND
                  (NRSEQITPROD = @V_NRSEQITPROD) AND
                  ((@V_QTITEMPROD > (@V_QTENTRMERC + ((ROUND(@V_QTENTRMERC,3) * @V_VRPTOLQTITAF)/100)))) AND
                  (@V_IDCONQTDEREC <> 'N');

            SET @V_DIFPROD = 'S';

            DECLARE C_PRODAUTF CURSOR  FOR
            SELECT DISTINCT CDPRODUTO
            FROM NFRELACAF
            WHERE CDFILIAL   = @P_CDFILIAL AND
                  NRLANCTONF = @P_NRLANCTONF;
            OPEN C_PRODAUTF;
            FETCH NEXT FROM C_PRODAUTF INTO @V_CPRODAF;

            WHILE (@@FETCH_STATUS = 0) BEGIN
               IF @V_CDPRODUTO = @V_CPRODAF BEGIN
                  SET @V_DIFPROD = 'N';
               END;
               FETCH NEXT FROM C_PRODAUTF INTO @V_CPRODAF;
            END;
            CLOSE C_PRODAUTF;
            DEALLOCATE C_PRODAUTF;

            UPDATE ITEMPRODUTO
            SET IDAVISOSITEM   = SUBSTRING(IDAVISOSITEM,1,5)+  '1'
            WHERE (CDFILIAL    = @P_CDFILIAL)                AND
                  (NRLANCTONF  = @P_NRLANCTONF)              AND
                  (NRSEQITPROD = @V_NRSEQITPROD)             AND
                  (@V_IDPRODNFAF <> 'N')                     AND
                  (@V_DIFPROD   = 'S');

            FETCH NEXT FROM C_ITEMAF INTO @V_CDFILIORIG, @V_NRSEQITPROD, @V_CDFILDEST, @V_CDFILLANC, @V_NRAUTOFORN, @V_CDPRODUTO, @V_CDMARCA, @V_DTPROGENTAF;
         END;
         CLOSE C_ITEMAF;
         DEALLOCATE C_ITEMAF;
      END;

      /* VERIFICAR SE A NOTA TEM AVISO */
      UPDATE NOTAFISCAL
      SET IDAVISOS = '1' + SUBSTRING(IDAVISOS,2, 4)
      WHERE CDFILIAL   = @P_CDFILIAL    AND
            NRLANCTONF = @P_NRLANCTONF  AND
            NRLANCTONF IN (SELECT MAX(NRLANCTONF) AS NRLANCTONF
                           FROM ITEMPRODUTO
                           WHERE CDFILIAL   = @P_CDFILIAL    AND
                                 NRLANCTONF = @P_NRLANCTONF  AND
                                 CHARINDEX('1', IDAVISOSITEM) > 0
                           UNION
                           SELECT NRLANCIMPOIT
                           FROM TRABITPROIMPOS
                           WHERE CDFILIMPOIT  = @P_CDFILIAL    AND
                                 NRLANCIMPOIT = @P_NRLANCTONF  AND
                                 CHARINDEX('1', IDAVISIMPOIT) > 0
                           UNION
                           SELECT NRLANCIMPTOT
                           FROM TRABIMPOSNFTOT
                           WHERE CDFILIMPTOT  = @P_CDFILIAL    AND
                                 NRLANCIMPTOT = @P_NRLANCTONF  AND
                                 CHARINDEX('1', IDAVISOSTOT) > 0);


      /* VERIFICAR SE A NOTA TEM ERRO */
      UPDATE NOTAFISCAL
      SET IDERROS = '1' + SUBSTRING(IDERROS,2,4)
      WHERE CDFILIAL   = @P_CDFILIAL    AND
            NRLANCTONF = @P_NRLANCTONF  AND
            NRLANCTONF IN (SELECT MAX(NRLANCTONF) AS NRLANCTONF
                           FROM ITEMPRODUTO
                           WHERE CDFILIAL   = @P_CDFILIAL    AND
                                 NRLANCTONF = @P_NRLANCTONF  AND
                                 CHARINDEX('1', IDERROSITEM) > 0
                           UNION
                           SELECT NRLANCIMPOIT
                           FROM TRABITPROIMPOS
                           WHERE CDFILIMPOIT  = @P_CDFILIAL    AND
                                 NRLANCIMPOIT = @P_NRLANCTONF  AND
                                 CHARINDEX('1', IDERRIMPOIT) > 0
                           UNION
                           SELECT NRLANCIMPTOT
                           FROM TRABIMPOSNFTOT
                           WHERE CDFILIMPTOT  = @P_CDFILIAL    AND
                                 NRLANCIMPTOT = @P_NRLANCTONF  AND
                                 CHARINDEX('1', IDERROSTOT) > 0);
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'CONFERE_ERROS_NF','6.19.XXX';
GO
